diff -Naur nagios-3.0.2.orig/base/notifications.c nagios-3.0.2/base/notifications.c
--- nagios-3.0.2.orig/base/notifications.c	2008-02-28 12:26:27.000000000 -0700
+++ nagios-3.0.2/base/notifications.c	2008-09-12 16:37:53.000000000 -0700
@@ -585,6 +585,13 @@
 	if(type==NOTIFICATION_DOWNTIMESTART || type==NOTIFICATION_DOWNTIMEEND || type==NOTIFICATION_DOWNTIMECANCELLED){
 
 		if(cntct->notify_on_service_downtime==FALSE){
+			if(type==NOTIFICATION_DOWNTIMEEND || type==NOTIFICATION_DOWNTIMECANCELLED){
+				if(cntct->notify_on_service_downtimestop==FALSE){
+					log_debug_info(DEBUGL_NOTIFICATIONS,2,"We shouldn't notify this contact about DOWNTIMEEND/DOWNTIMECANCELLED service events.\n");
+					return ERROR;
+					}
+				return OK;
+				}
 			log_debug_info(DEBUGL_NOTIFICATIONS,2,"We shouldn't notify this contact about DOWNTIME service events.\n");
 			return ERROR;
 		        }
@@ -592,6 +599,7 @@
 		return OK;
 	        }
 
+
 	/*************************************/
 	/*** ACKS AND NORMAL NOTIFICATIONS ***/
 	/*************************************/
@@ -1440,6 +1448,13 @@
 	if(type==NOTIFICATION_DOWNTIMESTART || type==NOTIFICATION_DOWNTIMEEND || type==NOTIFICATION_DOWNTIMECANCELLED){
 
 		if(cntct->notify_on_host_downtime==FALSE){
+			if(type==NOTIFICATION_DOWNTIMEEND || type==NOTIFICATION_DOWNTIMECANCELLED){
+				if(cntct->notify_on_host_downtimestop==FALSE){
+					log_debug_info(DEBUGL_NOTIFICATIONS,2,"We shouldn't notify this contact about DOWNTIMEEND/DOWNTIMECANCELLED host events.\n");
+					return ERROR;
+					}
+				return OK;
+				}
 			log_debug_info(DEBUGL_NOTIFICATIONS,2,"We shouldn't notify this contact about DOWNTIME host events.\n");
 			return ERROR;
 		        }
@@ -1447,7 +1462,6 @@
 		return OK;
 	        }
 
-
 	/*************************************/
 	/*** ACKS AND NORMAL NOTIFICATIONS ***/
 	/*************************************/
diff -Naur nagios-3.0.2.orig/cgi/config.c nagios-3.0.2/cgi/config.c
--- nagios-3.0.2.orig/cgi/config.c	2008-04-13 11:34:27.000000000 -0700
+++ nagios-3.0.2/cgi/config.c	2008-09-12 16:21:46.000000000 -0700
@@ -956,6 +956,10 @@
 			printf("%sDowntime",(options)?", ":"");
 			options=1;
 		        }
+		if(temp_contact->notify_on_service_downtimestop==TRUE){
+			printf("%sDowntimestop",(options)?", ":"");
+			options=1;
+			}
 		if(!options)
 			printf("None");
 		printf("</TD>\n");
@@ -982,6 +986,10 @@
 			printf("%sDowntime",(options)?", ":"");
 			options=1;
 		        }
+		if(temp_contact->notify_on_host_downtimestop==TRUE){
+			printf("%sDowntimestop",(options)?", ":"");
+			options=1;
+			}
 		if(!options)
 			printf("None");
 		printf("</TD>\n");
diff -Naur nagios-3.0.2.orig/common/objects.c nagios-3.0.2/common/objects.c
--- nagios-3.0.2.orig/common/objects.c	2008-04-13 11:34:27.000000000 -0700
+++ nagios-3.0.2/common/objects.c	2008-09-12 16:03:58.000000000 -0700
@@ -1408,7 +1408,7 @@
 
 
 /* add a new contact to the list in memory */
-contact *add_contact(char *name,char *alias, char *email, char *pager, char **addresses, char *svc_notification_period, char *host_notification_period,int notify_service_ok,int notify_service_critical,int notify_service_warning, int notify_service_unknown, int notify_service_flapping, int notify_service_downtime, int notify_host_up, int notify_host_down, int notify_host_unreachable, int notify_host_flapping, int notify_host_downtime, int host_notifications_enabled, int service_notifications_enabled, int can_submit_commands, int retain_status_information, int retain_nonstatus_information){
+contact *add_contact(char *name,char *alias, char *email, char *pager, char **addresses, char *svc_notification_period, char *host_notification_period,int notify_service_ok,int notify_service_critical,int notify_service_warning, int notify_service_unknown, int notify_service_flapping, int notify_service_downtime, int notify_service_downtimestop, int notify_host_up, int notify_host_down, int notify_host_unreachable, int notify_host_flapping, int notify_host_downtime, int notify_host_downtimestop, int host_notifications_enabled, int service_notifications_enabled, int can_submit_commands, int retain_status_information, int retain_nonstatus_information){
 	contact *new_contact=NULL;
 	int x=0;
 	int result=OK;
@@ -1476,11 +1476,13 @@
 	new_contact->notify_on_service_unknown=(notify_service_unknown>0)?TRUE:FALSE;
 	new_contact->notify_on_service_flapping=(notify_service_flapping>0)?TRUE:FALSE;
 	new_contact->notify_on_service_downtime=(notify_service_downtime>0)?TRUE:FALSE;
+	new_contact->notify_on_service_downtimestop=(notify_service_downtimestop>0)?TRUE:FALSE;
 	new_contact->notify_on_host_recovery=(notify_host_up>0)?TRUE:FALSE;
 	new_contact->notify_on_host_down=(notify_host_down>0)?TRUE:FALSE;
 	new_contact->notify_on_host_unreachable=(notify_host_unreachable>0)?TRUE:FALSE;
 	new_contact->notify_on_host_flapping=(notify_host_flapping>0)?TRUE:FALSE;
 	new_contact->notify_on_host_downtime=(notify_host_downtime>0)?TRUE:FALSE;
+	new_contact->notify_on_host_downtimestop=(notify_host_downtimestop>0)?TRUE:FALSE;
 	new_contact->host_notifications_enabled=(host_notifications_enabled>0)?TRUE:FALSE;
 	new_contact->service_notifications_enabled=(service_notifications_enabled>0)?TRUE:FALSE;
 	new_contact->can_submit_commands=(can_submit_commands>0)?TRUE:FALSE;
diff -Naur nagios-3.0.2.orig/include/objects.h nagios-3.0.2/include/objects.h
--- nagios-3.0.2.orig/include/objects.h	2008-03-31 12:09:36.000000000 -0700
+++ nagios-3.0.2/include/objects.h	2008-09-12 16:03:58.000000000 -0700
@@ -200,11 +200,13 @@
 	int     notify_on_service_recovery;
 	int     notify_on_service_flapping;
 	int     notify_on_service_downtime;
+	int	notify_on_service_downtimestop;
 	int 	notify_on_host_down;
 	int	notify_on_host_unreachable;
 	int	notify_on_host_recovery;
 	int     notify_on_host_flapping;
 	int     notify_on_host_downtime;
+	int	notify_on_host_downtimestop;
 	char	*host_notification_period;
 	char	*service_notification_period;
 	int     host_notifications_enabled;
@@ -635,7 +637,7 @@
 
 
 /**** Object Creation Functions ****/
-contact *add_contact(char *,char *,char *,char *,char **,char *,char *,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int);	/* adds a contact definition */
+contact *add_contact(char *,char *,char *,char *,char **,char *,char *,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int);	/* adds a contact definition */
 commandsmember *add_service_notification_command_to_contact(contact *,char *);				/* adds a service notification command to a contact definition */
 commandsmember *add_host_notification_command_to_contact(contact *,char *);				/* adds a host notification command to a contact definition */
 customvariablesmember *add_custom_variable_to_contact(contact *,char *,char *);                         /* adds a custom variable to a service definition */
diff -Naur nagios-3.0.2.orig/xdata/xodtemplate.c nagios-3.0.2/xdata/xodtemplate.c
--- nagios-3.0.2.orig/xdata/xodtemplate.c	2008-03-05 14:50:37.000000000 -0700
+++ nagios-3.0.2/xdata/xodtemplate.c	2008-09-12 16:03:58.000000000 -0700
@@ -1387,12 +1387,14 @@
 		new_contact->notify_on_host_recovery=FALSE;
 		new_contact->notify_on_host_flapping=FALSE;
 		new_contact->notify_on_host_downtime=FALSE;
+		new_contact->notify_on_host_downtimestop=FALSE;
 		new_contact->notify_on_service_unknown=FALSE;
 		new_contact->notify_on_service_warning=FALSE;
 		new_contact->notify_on_service_critical=FALSE;
 		new_contact->notify_on_service_recovery=FALSE;
 		new_contact->notify_on_service_flapping=FALSE;
 		new_contact->notify_on_service_downtime=FALSE;
+		new_contact->notify_on_service_downtimestop=FALSE;
 		new_contact->have_host_notification_options=FALSE;
 		new_contact->have_service_notification_options=FALSE;
 		new_contact->host_notifications_enabled=TRUE;
@@ -3131,12 +3133,15 @@
 					temp_contact->notify_on_host_flapping=TRUE;
 				else if(!strcmp(temp_ptr,"s") || !strcmp(temp_ptr,"downtime"))
 					temp_contact->notify_on_host_downtime=TRUE;
+				else if(!strcmp(temp_ptr,"e") || !strcmp(temp_ptr,"downtimestop"))
+					temp_contact->notify_on_host_downtimestop=TRUE;
 				else if(!strcmp(temp_ptr,"n") || !strcmp(temp_ptr,"none")){
 					temp_contact->notify_on_host_down=FALSE;
 					temp_contact->notify_on_host_unreachable=FALSE;
 					temp_contact->notify_on_host_recovery=FALSE;
 					temp_contact->notify_on_host_flapping=FALSE;
 					temp_contact->notify_on_host_downtime=FALSE;
+					temp_contact->notify_on_host_downtimestop=FALSE;
 				        }
 				else if(!strcmp(temp_ptr,"a") || !strcmp(temp_ptr,"all")){
 					temp_contact->notify_on_host_down=TRUE;
@@ -3144,6 +3149,7 @@
 					temp_contact->notify_on_host_recovery=TRUE;
 					temp_contact->notify_on_host_flapping=TRUE;
 					temp_contact->notify_on_host_downtime=TRUE;
+					temp_contact->notify_on_host_downtimestop=TRUE;
 				        }
 				else{
 #ifdef NSCORE
@@ -3168,6 +3174,8 @@
 					temp_contact->notify_on_service_flapping=TRUE;
 				else if(!strcmp(temp_ptr,"s") || !strcmp(temp_ptr,"downtime"))
 					temp_contact->notify_on_service_downtime=TRUE;
+				else if(!strcmp(temp_ptr,"e") || !strcmp(temp_ptr,"downtimestop"))
+					temp_contact->notify_on_service_downtimestop=TRUE;
 				else if(!strcmp(temp_ptr,"n") || !strcmp(temp_ptr,"none")){
 					temp_contact->notify_on_service_unknown=FALSE;
 					temp_contact->notify_on_service_warning=FALSE;
@@ -3175,6 +3183,7 @@
 					temp_contact->notify_on_service_recovery=FALSE;
 					temp_contact->notify_on_service_flapping=FALSE;
 					temp_contact->notify_on_service_downtime=FALSE;
+					temp_contact->notify_on_service_downtimestop=FALSE;
 				        }
 				else if(!strcmp(temp_ptr,"a") || !strcmp(temp_ptr,"all")){
 					temp_contact->notify_on_service_unknown=TRUE;
@@ -3183,6 +3192,7 @@
 					temp_contact->notify_on_service_recovery=TRUE;
 					temp_contact->notify_on_service_flapping=TRUE;
 					temp_contact->notify_on_service_downtime=TRUE;
+					temp_contact->notify_on_service_downtimestop=FALSE;
 				        }
 				else{
 #ifdef NSCORE
@@ -7676,6 +7686,7 @@
 			this_contact->notify_on_host_recovery=template_contact->notify_on_host_recovery;
 			this_contact->notify_on_host_flapping=template_contact->notify_on_host_flapping;
 			this_contact->notify_on_host_downtime=template_contact->notify_on_host_downtime;
+			this_contact->notify_on_host_downtimestop=template_contact->notify_on_host_downtimestop;
 			this_contact->have_host_notification_options=TRUE;
 	                }
 		if(this_contact->have_service_notification_options==FALSE && template_contact->have_service_notification_options==TRUE){
@@ -7685,6 +7696,7 @@
 			this_contact->notify_on_service_recovery=template_contact->notify_on_service_recovery;
 			this_contact->notify_on_service_flapping=template_contact->notify_on_service_flapping;
 			this_contact->notify_on_service_downtime=template_contact->notify_on_service_downtime;
+			this_contact->notify_on_service_downtimestop=template_contact->notify_on_service_downtimestop;
 			this_contact->have_service_notification_options=TRUE;
 	                }
 		if(this_contact->have_host_notifications_enabled==FALSE && template_contact->have_host_notifications_enabled==TRUE){
@@ -10290,7 +10302,7 @@
 		return OK;
 
 	/* add the contact */
-	new_contact=add_contact(this_contact->contact_name,this_contact->alias,this_contact->email,this_contact->pager,this_contact->address,this_contact->service_notification_period,this_contact->host_notification_period,this_contact->notify_on_service_recovery,this_contact->notify_on_service_critical,this_contact->notify_on_service_warning,this_contact->notify_on_service_unknown,this_contact->notify_on_service_flapping,this_contact->notify_on_service_downtime,this_contact->notify_on_host_recovery,this_contact->notify_on_host_down,this_contact->notify_on_host_unreachable,this_contact->notify_on_host_flapping,this_contact->notify_on_host_downtime,this_contact->host_notifications_enabled,this_contact->service_notifications_enabled,this_contact->can_submit_commands,this_contact->retain_status_information,this_contact->retain_nonstatus_information);
+	new_contact=add_contact(this_contact->contact_name,this_contact->alias,this_contact->email,this_contact->pager,this_contact->address,this_contact->service_notification_period,this_contact->host_notification_period,this_contact->notify_on_service_recovery,this_contact->notify_on_service_critical,this_contact->notify_on_service_warning,this_contact->notify_on_service_unknown,this_contact->notify_on_service_flapping,this_contact->notify_on_service_downtime,this_contact->notify_on_service_downtimestop,this_contact->notify_on_host_recovery,this_contact->notify_on_host_down,this_contact->notify_on_host_unreachable,this_contact->notify_on_host_flapping,this_contact->notify_on_host_downtime,this_contact->notify_on_host_downtimestop,this_contact->host_notifications_enabled,this_contact->service_notifications_enabled,this_contact->can_submit_commands,this_contact->retain_status_information,this_contact->retain_nonstatus_information);
 
 	/* return with an error if we couldn't add the contact */
 	if(new_contact==NULL){
@@ -11746,6 +11758,8 @@
 			fprintf(fp,"%sf",(x++>0)?",":"");
 		if(temp_contact->notify_on_service_downtime==TRUE)
 			fprintf(fp,"%ss",(x++>0)?",":"");
+		if(temp_contact->notify_on_service_downtimestop==TRUE)
+			fprintf(fp,"%se",(x++>0)?",":"");
 		if(x==0)
 			fprintf(fp,"n");
 		fprintf(fp,"\n");
@@ -11761,6 +11775,8 @@
 			fprintf(fp,"%sf",(x++>0)?",":"");
 		if(temp_contact->notify_on_host_downtime==TRUE)
 			fprintf(fp,"%ss",(x++>0)?",":"");
+		if(temp_contact->notify_on_host_downtimestop==TRUE)
+			fprintf(fp,"%se",(x++>0)?",":"");
 		if(x==0)
 			fprintf(fp,"n");
 		fprintf(fp,"\n");
diff -Naur nagios-3.0.2.orig/xdata/xodtemplate.h nagios-3.0.2/xdata/xodtemplate.h
--- nagios-3.0.2.orig/xdata/xodtemplate.h	2008-02-28 12:27:55.000000000 -0700
+++ nagios-3.0.2/xdata/xodtemplate.h	2008-09-12 16:03:58.000000000 -0700
@@ -159,6 +159,7 @@
 	int       notify_on_host_recovery;
 	int       notify_on_host_flapping;
 	int       notify_on_host_downtime;
+	int       notify_on_host_downtimestop;
 	char      *service_notification_period;
 	char      *service_notification_commands;
 	int       notify_on_service_unknown;
@@ -167,6 +168,7 @@
 	int       notify_on_service_recovery;
 	int       notify_on_service_flapping;
 	int       notify_on_service_downtime;
+	int       notify_on_service_downtimestop;
 	int       host_notifications_enabled;
 	int       service_notifications_enabled;
 	int       can_submit_commands;
